import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.*;
import javax.swing.*;

public class Differentiate extends myFilter{
    TextField td_left,td_right,td_up,td_down,td_self;
    double d_diff_left=0,d_diff_right=0,d_diff_up=0,d_diff_down=0,d_diff_self=0;
    JLabel l_diff;
    
	Differentiate(Stml.F_topo f,double dl,double dr,double du,double dd,double ds){
        super(f);

        
        d_diff_left=dl;
        d_diff_right=dr;
        d_diff_up=du;
        d_diff_down=dd;
        d_diff_self=ds;

        //      Differentiate Panel
        p_ptool=new Panel();
        p_ptool.setLayout(new GridBagLayout());
        GridBagConstraints c=new GridBagConstraints();
        c.fill=GridBagConstraints.BOTH;
        c.insets=new Insets(5,5,5,5);
        c.weightx=c.weighty=0.0;
        l_diff=new JLabel("Differentiate weights:");
        td_left =new TextField(""+d_diff_left);
        td_right=new TextField(""+d_diff_right);
        td_up   =new TextField(""+d_diff_up);
        td_down =new TextField(""+d_diff_down);
        td_self =new TextField(""+d_diff_self);
        c.gridx=0;c.gridy=0;c.gridwidth=3;c.gridheight=1;
        p_ptool.add(l_diff ,c);
        c.gridx=0;c.gridy=2;c.gridwidth=1;c.gridheight=1;
        p_ptool.add(td_left ,c);
        c.gridx=2;c.gridy=2;c.gridwidth=1;c.gridheight=1;
        p_ptool.add(td_right,c);
        c.gridx=1;c.gridy=1;c.gridwidth=1;c.gridheight=1;
        p_ptool.add(td_up   ,c);
        c.gridx=1;c.gridy=3;c.gridwidth=1;c.gridheight=1;
        p_ptool.add(td_down ,c);
        c.gridx=1;c.gridy=2;c.gridwidth=1;c.gridheight=1;
        p_ptool.add(td_self ,c);
        p_ptool.setVisible(false);
        ActionListener td_al=new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            try {
              d_diff_left=Double.parseDouble(td_left.getText());
              d_diff_right=Double.parseDouble(td_right.getText());
              d_diff_up=Double.parseDouble(td_up.getText());
              d_diff_down=Double.parseDouble(td_down.getText());
              d_diff_self=Double.parseDouble(td_self.getText());
            } catch (NumberFormatException ex) {
              System.out.println("NumberFormatException: "+ex.getMessage());
            }
            td_left.setText(""+d_diff_left);
            td_right.setText(""+d_diff_right);
            td_up.setText(""+d_diff_up);
            td_down.setText(""+d_diff_down);
            td_self.setText(""+d_diff_self);
            f_topo.updateframe(f_topo.p_topo);
          }
        };
        td_left.addActionListener(td_al);
        td_right.addActionListener(td_al);
        td_up.addActionListener(td_al);
        td_down.addActionListener(td_al);
        td_self.addActionListener(td_al);
        f_topo.add(p_ptool);
	}

	public void doit() {
        int tempdata[][];
        int xco,yco,min_ad;
        int im_xsize,im_ysize;
        double a,wl,wo,wu,wr,ws;
        
        min_ad=f_topo.min_ad;
        im_xsize=f_topo.im_xsize;
        im_ysize=f_topo.im_ysize;
        wl=d_diff_left;
        wo=d_diff_up;
        wu=d_diff_down;
        wr=d_diff_right;
        ws=d_diff_self;
        
        tempdata=new int[im_xsize][im_ysize];
        for(yco=0;yco<im_ysize;yco++) 
          for(xco=0;xco<im_xsize;xco++) tempdata[xco][yco]=f_topo.workdata[xco][yco];

        for(yco=1;yco<im_ysize-1;yco++) {
          for(xco=1;xco<im_xsize-1;xco++) {
            a=(wl*(f_topo.workdata[xco-1][yco  ]-min_ad)+
               wo*(f_topo.workdata[xco  ][yco-1]-min_ad)+
               wu*(f_topo.workdata[xco  ][yco+1]-min_ad)+
               wr*(f_topo.workdata[xco+1][yco  ]-min_ad)+
               ws*(f_topo.workdata[xco  ][yco  ]-min_ad) );
            tempdata[xco][yco]=(int) a;
          }
        }
// Rnder korrigieren
        for(xco=1;xco<im_xsize-1;xco++) {
          tempdata[xco][0]=tempdata[xco][1];
          tempdata[xco][im_ysize-1]=tempdata[xco][im_ysize-2];
        }
        for(yco=1;yco<im_ysize-1;yco++) {
          tempdata[0][yco]=tempdata[1][yco];
          tempdata[im_xsize-1][yco]=tempdata[im_xsize-2][yco];
        }
        tempdata[0][0]=tempdata[1][0];
        tempdata[im_xsize-1][0]=tempdata[im_xsize-1][1];
        tempdata[0][im_ysize-1]=tempdata[1][im_ysize-1];
        tempdata[im_xsize-1][im_ysize-1]=tempdata[im_xsize-1][im_ysize-2];
        for(yco=0;yco<im_ysize;yco++) 
          for(xco=0;xco<im_xsize;xco++) f_topo.workdata[xco][yco]=tempdata[xco][yco];
		
	}
	
}
