
public class PlaneX extends myFilter{
	PlaneX(Stml.F_topo f){
        super(f);
	}
	
	public void doit() {
        int xco,yco,datum;
        double da,db,dc,dd,de,df,dg,dh,di,dj,dk,dl;
        double rA=0,rB=0,rC=0;
        double ddet;
/*        
N data points

z=A+Bx+Cy
(A+Bx+Cy-z)^2 -> min

A^2+ABx+ACy-Az+
ABx+B^2x^2+BCxy-Bxz+
ACy+BCxy+C^2y^2-Cyz+
-Az-Bxz-Cyz+z^2

A^2+2ABx+2ACy-2Az+B^2x^2+2BCxy-2Bxz+C^2y^2-2Cyz+z^2

partial and set 0
df
-- = 2AN+2Bx+2Cy-2z = 0
dA

df
-- = 2Ax+2Bxx+2Cxy-2xz
dB

df
-- = 2Ay+2Bxy+2Cyy-2yz
dC

System brackets [] are sums from i=0..N :

  N  [x]  [y]    A    [z]
 [x] [xx] [xy]   B  = [xz]
 [y] [xy] [yy]   C    [yz]
 
for small program Cramers Rule:
    D1
A = --  with Determinant D1 is D with first row replaced by [z] [xz] [yz] (perpendicular)
    D

    D2
B = -- with second row replaced a.s.o.
    D
    
solution of determinant by rule of sarrus:
     a b c 
det  d e f = aei+bfg+cdh - (ceg+afh+bdi)
     g h i
    
*/
        
// check if any point is selected
        da=db=dc=dd=de=df=dg=dh=di=dj=dk=dl=0;
// calculate coefficient sums
        for(yco=0;yco<f_topo.im_ysize;yco++) 
            for(xco=0;xco<f_topo.im_xsize;xco++) {
            	  datum=f_topo.workdata[xco][yco];
            	  da++;
            	  db+=xco;
            	  dc+=yco;
//            	  dd+=xco;
            	  de+=(xco*xco);
               	  df+=(xco*yco);
//                dg+=yco;
//             	  dh+=(xco*yco);
               	  di+=(yco*yco);
               	  dj+=datum;
               	  dk+=(xco*datum);
               	  dl+=(yco*datum);
              }
        dd=db;
        dg=dc;
        dh=df;
        ddet=det(da,db,dc,dd,de,df,dg,dh,di);
        if (ddet!=0) {
        	rA=det(dj,db,dc,dk,de,df,dl,dh,di)/ddet;
        	rB=det(da,dj,dc,dd,dk,df,dg,dl,di)/ddet;
        	rC=det(da,db,dj,dd,de,dk,dg,dh,dl)/ddet;
        } else {
        	System.out.println("PlaneX: Determinant==0 !");
        }
        for(yco=0;yco<f_topo.im_ysize;yco++) 
            for(xco=0;xco<f_topo.im_xsize;xco++) 
              f_topo.workdata[xco][yco]-=(rA+rB*xco);
	}
	
	double det(double a,double b,double c,double d,double e,double f,double g,double h,double i) {
		return (a*e*i+b*f*g+c*d*h)-(c*e*g+a*f*h+b*d*i);
	}

}
