import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;

public class addThumbThread extends Thread {
    String currentdir;
    stmlbrowser stmb;
    boolean bo_aline;
    imagedata imd;
    int toponr;
    
    addThumbThread(stmlbrowser stmb,imagedata imda,String cdir,boolean boa,int tp) {
        this.stmb=stmb;
        currentdir=cdir;
        bo_aline=boa;
        imd=imda;
        toponr=tp;
    }

    public static String trimm(String para) {
    	   while( (para.indexOf(" ")==0) && (para.length()>0)) para=para.substring(1,para.length());
    	   while((para.lastIndexOf(" ")==para.length()-1) && (para.length()>0)) para=para.substring(0,para.length()-1);
    	   return para;
    	}

    public void run() {
    	
    	  final int umschaltcap=10000; // ab diesem delta wird Wandlerbereichsumschaltung angenommen
    	  BufferedImage im_data;        
    	  int origdata[],off_x[];
    	  int xco,yco,im_xsize,im_ysize;
    	  int buf_pos,ad_value,old_adval,offset,tval;
    	  int lowb,highb,buf_size,dp;
    	  int topocnt;
    	  byte databuffer[];
    	  File fil;
    	  FileReader fr=null;
    	  BufferedReader in=null;
    	  String fdatname,line,kw;
    	  int i,i1,i2;
    	  int val,delta,lo_val,hi_val;
    	  double scale;
    	  boolean highfirst;
    	  boolean ispcocam=false;
    	  String addinfo;

    	  
    	  double inttab[]={0,0.11,0.18,0.19,0.22,0.29,0.3,0.4,0.41,0.48,0.52,0.59,0.6,0.7,0.71,0.78,0.81,0.82,0.89};
    	  int      rtab[]={0,0   ,-1  ,1   ,0   ,-1  ,1  ,-1 ,1   ,0   ,1   ,0   ,2  ,0  ,2   ,1   ,0   ,2   ,1   };
    	  int      gtab[]={0,0   ,1   ,0   ,0   ,1   ,0  ,1  ,0   ,1   ,0   ,1   ,0  ,1  ,0   ,1   ,1   ,0   ,1   };
    	  int      btab[]={0,1   ,-1  ,-1  ,2   ,0   ,0  ,1  ,1   ,-1  ,2   ,0   ,0  ,1  ,1   ,-1  ,2   ,2   ,0   };
    	  double inten,inten2,intdif;
    	  int col_r,col_g,col_b,intpos;
    	  
    	  MouseListener mlis=new MouseAdapter() {
    		    public void mouseClicked(MouseEvent e) {
    		    	String pname=null;
    		    	imagedata imd;
    		    	int ele;
    		    	int but=e.getButton();
    		    	boolean addIt;
    		    	
    		    	for(ele=0;ele<stmb.thumbnails.size();ele++) {
    		    		imd=(imagedata) stmb.thumbnails.elementAt(ele);
    		    		if (e.getSource().equals(imd.ip)) {
    		    		  pname=imd.parfilename;
    	                  System.out.println("Opening:"+currentdir+pname);
    	                  if (but==3) {
    	                	  addIt=true;
    	                  } else{
    	                	  addIt=false;
    	                  }
    	                  stmb.dasparent.preopen(currentdir+File.separator,pname,addIt,null);
    		    		}
    		    	}
    		    }
    	  };
    	  
    	  
    	  
    	  //  System.out.println("Opening file "+currentdir+File.separator+fname);
    	  Color bgColor=imd.ip.getBackground();
    	  imd.ip.setBackground(new Color(255,200,100));
    	  im_xsize=0;
    	  im_ysize=0;
    	  fdatname=null;
    	  topocnt=0;
    	  try {
    	    fil = new File(currentdir,imd.parfilename);
    	    fr = new FileReader(fil);
    	    in = new BufferedReader(fr);
    	    in.mark(65536);
    	    while((line=in.readLine()) != null) {
      	      kw="; Original run/scan cycle identification: ";
    	      i=line.indexOf(kw);
    	      if (i>-1) {
    	          line=line.substring(i+kw.length(),line.length());
    	          line=trimm(line);
    	          imd.data[11][1]=line;
    	      }
    	      dp=line.lastIndexOf(";"); if (dp >-1) line=line.substring(0,dp);
    	      if (line.indexOf("System")==0) {
      	          line=line.substring(line.lastIndexOf(":")+1,line.length());
      	          line=trimm(line);
      	          if (line.indexOf("PCO_Cam")==0) {
      	        	ispcocam=true;
      	          }
      	      }
    	      if (line.indexOf("Image Size in X")==0) {
    	        if (im_xsize==0) {
    	          line=line.substring(line.lastIndexOf(":")+1,line.length());
    	          line=trimm(line);
    	          im_xsize=Integer.parseInt(line);
    	          imd.data[0][1]=line;
    	        }
    	      }
    	      if (line.indexOf("Field X Size in nm")==0) {
    	          if (imd.x.equals(" ")) {
    	            line=line.substring(line.lastIndexOf(":")+1,line.length());
    	            imd.x=trimm(line);
    	            imd.data[2][1]=imd.x;
    	          }
    	        }
    	      if (line.indexOf("Image Size in Y")==0) {
    	        if (im_ysize==0) {
    	          line=line.substring(line.lastIndexOf(":")+1,line.length());
    	          line=trimm(line);
    	          im_ysize=Integer.parseInt(line);
    	          imd.data[1][1]=line;

    	        }
    	      }
    	      if (line.indexOf("Field Y Size in nm")==0) {
    	          if (imd.y.equals(" ")) {
    	            line=line.substring(line.lastIndexOf(":")+1,line.length());
    	            imd.y=trimm(line);
    	            imd.data[3][1]=imd.y;

    	          }
    	        }
    	      if (line.indexOf("Gap Voltage")==0) {
    	            line=line.substring(line.lastIndexOf(":")+1,line.length());
    	            imd.voltf=trimm(line);
    	            imd.data[4][1]=imd.voltf;

    	            line=in.readLine();
    	            dp=line.lastIndexOf(";"); if (dp >-1) line=line.substring(0,dp);
                    if (line.indexOf(":")<0) {
        	            imd.voltb=trimm(line);
        	            imd.data[5][1]=imd.voltb;

                    } else {
        	            imd.data[5][1]="n/a";
                    	// if there is a : it is probably Feedback Set
        	    	      if (line.indexOf("Feedback Set")==0) {
       	    	            line=line.substring(line.lastIndexOf(":")+1,line.length());
       	    	            line=trimm(line);
       	    	            imd.data[9][1]=line;
       	    	            // if there is no backward for Gap voltage we dont need to check for backward feedback
        	    	      }
        	            
                    }
    	        }
    	      if (line.indexOf("Feedback Set")==0) {
    	          line=line.substring(line.lastIndexOf(":")+1,line.length());
    	          line=trimm(line);
    	          imd.data[9][1]=line;
    	        }
    	      if (line.indexOf("Spectroscopy Channel")==0) {
    	          line=line.substring(line.lastIndexOf(":")+1,line.length());
    	          line=trimm(line);
    	          imd.data[10][1]="YES";
    	        }
    	      if (line.indexOf("Measured Gap Voltage")==0) {
    	          line=line.substring(line.lastIndexOf(":")+1,line.length());
    	          imd.voltm=trimm(line);
    	          imd.data[6][1]=imd.voltm;
    	        }
    	      if (line.indexOf("Topographic Channel")==0) {
    	        line=in.readLine();
    	        line=trimm(line);
    	        if ( toponr==topocnt) {
                  imd.direction=line;
    	          imd.data[7][1]=line;

    	          for(i=0;i<7;i++) line=in.readLine();
                  dp=line.lastIndexOf(";"); if (dp >-1) line=line.substring(0,dp);
    	          line=trimm(line);
    	          fdatname=line;
    	          imd.data[8][1]=line;
    	        }
    	        topocnt++;
    	      }
    	    }
    	    in.close();
    	  } catch (Exception e) {
    		  System.out.println("File Error: "+e.getMessage());
//    	    JOptionPane.showMessageDialog(stmb,e.getMessage(),"File Error",JOptionPane.ERROR_MESSAGE);
    	    fdatname=null;
    	  }
    	  if (topocnt>stmb.maxtopo) stmb.maxtopo=topocnt;
//    	  System.out.println("Result: "+fdatname+" "+im_xsize+"x"+im_ysize);
    	  if (fdatname!=null) {
    	    buf_size=im_xsize*im_ysize;
    	    databuffer=new byte[buf_size*2];
    	  //Daten einlesen
//    	  System.out.println("Opening file: "+currentdir+File.separator+fdatname);
    		fil=new File(currentdir,fdatname);
    	  	FileInputStream fis=null;
    	  	try {
    	      fis=new FileInputStream(fil);
//    	      int bytes_read;
    	      while (fis.read(databuffer) != -1) {;}
    	    } catch (Exception e) {
    	      System.out.println("File Error: "+e.getMessage());
    	      fdatname=null;
    	    }
    	    finally {
    	      if (fis != null) try {fis.close();}catch(IOException e){;}
    	    }
    	    // Daten umlesen
            highfirst=false;
            if (Integer.parseInt(stmb.dasparent.v_option.opts[35])>0) highfirst=true; // high byte first
            if (ispcocam) highfirst=false;
            
    		origdata=new int[buf_size];
    				old_adval = offset = 0;
    				for (yco = 0; yco < im_ysize; yco++) {
    					i1=2*yco*im_xsize;
    					for (xco = 0; xco < im_xsize; xco++) {
    						buf_pos = i1 + xco*2;
    						// 16 bit signed Integer erzeugen
    						highb = databuffer[buf_pos];
    						if (highb < 0)
    							highb = 256 + highb;
    						lowb = databuffer[buf_pos + 1];
    						if (lowb < 0)
    							lowb = 256 + lowb;
    			            if (highfirst) { // high byte first
    			            	ad_value = (highb << 8) | lowb;
//    			            	ad_value=highb*256+lowb;
    			            } else {
    			            	ad_value = (lowb << 8) | highb;
//    			                ad_value=highb+256*lowb;
    			            }

    						
    						if (xco == 0)
    							offset = 0;
    						if (xco > 0) {
    							tval = ad_value - old_adval;
    							if (tval < 0)
    								tval = -tval;
    							if (tval > 32767) {
    								// running offset
    								if (ad_value > 32768) {
    									offset -= 65536;
    								} else {
    									offset += 65536;
    								}
    							}
    						}
    						old_adval = ad_value;
    						origdata[xco+im_xsize*(im_ysize - yco - 1)] = ad_value + offset;
    					}
    				}

    			    double mid_y[], mid_x[];
    				double a, b, mx, my, nx, ny, midx, midy, dum;

    				// Antiline
                    if (!ispcocam) {
    				if (bo_aline) {
    					int line_median;
    					int sum;

    					for (yco = 0; yco < im_ysize; yco++) {
    						sum = 0;
    						i=im_xsize*yco;
    						for (xco = 0; xco < im_xsize; xco++)
    							sum += origdata[xco+i];
    						line_median = sum / im_xsize;
    						for (xco = 0; xco < im_xsize; xco++)
    							origdata[xco+i] -= line_median;
    					}
    					my = ny = 0;
    				} else {

    					// Wandlerbereichsumschaltung erkennen und bereinigen
    					double[] dmid_x;
    					double[] doff_x;

    					dmid_x = new double[im_ysize];
    					doff_x = new double[im_ysize];
    					doff_x[0] = 0;
    					for (yco = 0; yco < im_ysize; yco++) {
    						i = 0;
    						i1=im_xsize*yco;
    						for (xco = 0; xco < im_xsize; xco++)
    							i += origdata[xco+i1];
    						dmid_x[yco] = i / im_xsize;
    					}
    					i = 0;
    					for (yco = 2; yco < im_ysize; yco++) {
    						if (Math.abs(dmid_x[yco - 1] - dmid_x[yco]) > umschaltcap)
    							i += (dmid_x[yco - 1] - dmid_x[yco])
    									+ (dmid_x[yco - 1] - dmid_x[yco - 2]);
    						doff_x[yco] = i;
    					}
    					for (yco = 0; yco < im_ysize; yco++) {
    						i1=im_xsize*yco;
    						for (xco = 0; xco < im_xsize; xco++)
    							origdata[xco+i1] += doff_x[yco];
    					}
    					// PlaneY
    					mid_x = new double[im_ysize];
    					midx = 0;
    					for (yco = 0; yco < im_ysize; yco++) {
    						i = 0;
    						i1=im_xsize*yco;
    						for (xco = 0; xco < im_xsize; xco++)
    							i += origdata[xco+i1];
    						mid_x[yco] = i / (double) im_xsize;
    						midx += mid_x[yco];
    					}
    					midx = midx / (double) im_ysize;
    					midy = im_ysize / (double) 2;
    					a = b = 0;
    					for (yco = 0; yco < im_ysize; yco++) {
    						dum = yco - midy;
    						a += dum * (mid_x[yco] - midx);
    						b += dum * dum;
    					}
    					my = a / b;
    					ny = midx - my * midy;

    				}
//    	 PlaneX
    	    
    	    mid_y=new double[im_xsize];
    	    midy=0;
    	    for(xco=0;xco<im_xsize;xco++) {
    	      i=0;
    	      for(yco=0;yco<im_ysize;yco++) i+=origdata[xco+im_xsize*yco];
    	      mid_y[xco]=i/(double)im_ysize;
    	      midy+=mid_y[xco];
    	    }
    	    midy=midy/(double)im_xsize;
    	    midx=im_xsize/(double)2;
    	    a=b=0;
    	    for(xco=0;xco<im_xsize;xco++) {
    	    	dum=xco-midx;
    	    	a+=dum*(mid_y[xco]-midy);
    	    	b+=dum*dum;
    	    }
    	    mx=a/b;
    	    nx = midy-mx*midx;
    	    
    	    for(yco=0;yco<im_ysize;yco++) {
    	    	i1=im_xsize*yco;
    	    	for(xco=0;xco<im_xsize;xco++) 
    	    	  origdata[xco+i1]-=(int) (mx*xco+nx + my*yco+ny);
    	    }
            } // !ispcocam

//    	 minmax    
    	    lo_val=Integer.MAX_VALUE;
    	    hi_val=Integer.MIN_VALUE;
    	    for(i=0;i<buf_size;i++) {
    	    	i1=origdata[i];
    	        if (i1<lo_val) lo_val=i1-1;
    	        if (i1>hi_val) hi_val=i1+1;
    	    }

//    	 Borders by Histogramvolume
    	    int datasize=(hi_val-lo_val)+1;
//    	    System.out.println("Datasize: "+datasize);
    	    off_x=new int[datasize];
    	    for(i=0;i<datasize;i++) off_x[i]=0;
    	    for(i=0;i<buf_size;i++) off_x[origdata[i]-lo_val]++;
//    	 Grenzen vorschlagen        
    	    int d_border=(int) (buf_size*stmb.histo_border); // Faktor 0.06
    	    // von links
    	    i1=i2=0;
    	    while (i2<d_border) {
    	      i2+=off_x[i1];
    	      i1++;
    	    }
    	    int min_sug=i1+lo_val;
    	    // von rechts
    	    i2=0;
    	    i1=datasize-1;
    	    while (i2<d_border) {
    	      i2+=off_x[i1];
    	      i1--;
    	    }
    	    int max_sug=i1+lo_val;
    	    if (max_sug<=min_sug) max_sug=min_sug+1;

//    	 Do Image
    	    delta=max_sug-min_sug;
//    	 Intensitaet = 0.3 R + 0.59 G + 0.11 B nach NTSC
    	/*

    						if (stmb.showgrey) {
    					for (i = 0; i < buf_size; i++) {
    							if (origdata[i] < min_sug) {
    								val = 0xff000000;
    							} else {
    								if (origdata[i] > max_sug) {
    									val = 0xffffffff;
    								} else {
    									inten = (origdata[i] - min_sug) * 255
    											/ ((double) (delta));
    									inten2 = inten - ((int) (inten));
    									intdif = 1;
    									intpos = 0;
    									for (i2 = 0; i2 < inttab.length; i2++) {
    										if (intdif > Math.abs(inttab[i2] - inten2)) {
    											intdif = Math.abs(inttab[i2] - inten2);
    											intpos = i2;
    										}
    									}
    									col_r = rtab[intpos] + ((int) (inten));
    									if (col_r < 0)
    										col_r = 0;
    									if (col_r > 255)
    										col_r = 255;
    									col_g = gtab[intpos] + ((int) (inten));
    									if (col_g < 0)
    										col_g = 0;
    									if (col_g > 255)
    										col_g = 255;
    									col_b = btab[intpos] + ((int) (inten));
    									if (col_b < 0)
    										col_b = 0;
    									if (col_b > 255)
    										col_b = 255;
    									val = 0xff000000 | (col_r << 16) | (col_g << 8)
    											| col_b;
    								}
    							}
    							origdata[i] = val;
    					}
    				} else
    				    	*/  
 
    				{
    					for (i = 0; i < buf_size; i++) {
    							val = (origdata[i] - min_sug) * 255 / delta;
    							if (val < 0) {
    								val = 0;
    							} else {
    								if (val > 255)
    									val = 255;
    							}
    							val = 0xff000000 | (val << 16) | (val << 8) | val;
    							origdata[i] = val;
    					}
    				}
// for future, colored thumbnails, but need about 4x memory    						
//       	    im_data=new BufferedImage(im_xsize,im_ysize,BufferedImage.TYPE_INT_ARGB);
      	    im_data=new BufferedImage(im_xsize,im_ysize,BufferedImage.TYPE_BYTE_GRAY);
// automatic conversion takes place      	    
    	    im_data.setRGB(0,0,im_xsize,im_ysize,origdata,0,im_xsize);
    	    origdata=null;
    	    double scalex=im_xsize/((double) (stmb.thumb_x));
    	    double scaley=im_ysize/((double) (stmb.thumb_y));
    	    if (scalex>scaley) {scale=scalex;} else {scale=scaley;}
    	    imd.im_shrinked=im_data.getScaledInstance((int) (im_xsize/scale),(int) (im_ysize/scale),Image.SCALE_DEFAULT);
    	    im_data=null;
    	    imd.ip.remove(imd.jl);
    	    imd.jl=null;
    	    imd.jl=new JLabel(new ImageIcon(imd.im_shrinked));
    	    GridBagConstraints gc=new GridBagConstraints();
    	    gc.fill=GridBagConstraints.BOTH;
    	    gc.insets=new Insets(1,1,1,1);
    	    gc.gridwidth=1;gc.gridheight=1;
    	    gc.weightx=gc.weighty=1.0;
    	    gc.gridx=0;gc.gridy=0;
    	    imd.ip.add(imd.jl,gc);
        	if (imd.direction.equalsIgnoreCase("Forward")) {
       		 	imd.ip.setBackground(new Color(220,230,220));
        	} else {
        		imd.ip.setBackground(new Color(220,220,255));
        	}
    	    String svolt;
            if (Integer.parseInt(stmb.dasparent.v_option.opts[37])>0) {
            	svolt=imd.voltm;
            } else {
            	if (imd.direction.equalsIgnoreCase("Forward")) {
            		svolt=imd.voltf;
                	if (svolt.equalsIgnoreCase(" ")) {
                		svolt=imd.voltm;
                	}
            	} else {
            		svolt=imd.voltb;
                	if (svolt.equalsIgnoreCase(" ")) {
                		svolt=imd.voltm;
                	}
            	}
            }
            addinfo="";
            if ((imd.data[10][1]!=null)&&(fdatname!=null)) {
//            	System.out.println("imd.data: "+imd.data[10][1]);
            	if (imd.data[10][1].indexOf("YES")==0) {
            		addinfo=" +S";
//            		System.out.println("SpecLabel");
            		imd.jname.setText(fdatname+addinfo);
            		imd.jname.setForeground(new Color(150,0,0));
            	}
            }

    	    imd.ip.setToolTipText(imd.parfilename + " / " + imd.x+ " x " + imd.y + " nm / " + svolt + " V "+imd.direction);
    	    imd.ip.validate();
    	    stmb.setTitle("JSTML Browser loading "+((int) (Runtime.getRuntime().totalMemory()-Runtime.getRuntime().freeMemory())/(1024*1024))+"M of "+((int) (Runtime.getRuntime().totalMemory())/(1024*1024))+" M");

/*
    	    imd.ip=new JPanel();
    	    imd.ip.setLayout(new GridBagLayout());
    	    GridBagConstraints gc=new GridBagConstraints();
    	    gc.fill=GridBagConstraints.BOTH;
    	    gc.insets=new Insets(1,1,1,1);
    	    gc.gridwidth=1;gc.gridheight=1;
    	    gc.weightx=gc.weighty=1.0;
    	    gc.gridx=0;gc.gridy=0;

    	    im_element.ip.add(new JLabel(new ImageIcon(im_element.im_shrinked)),gc);
    	    gc.weightx=gc.weighty=0.0;
    	    gc.gridx=0;gc.gridy=1;
    	    JLabel jl=new JLabel(im_element.parfilename);
    	    jl.setHorizontalAlignment(SwingConstants.CENTER);
    	    im_element.ip.add(jl,gc);
    	    im_element.ip.addMouseListener(mlis);
    	    im_element.ip.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createRaisedBevelBorder(),BorderFactory.createRaisedBevelBorder()));
    	    stmb.thumbnails.add(im_element);
    	    */
    	  }

//      	  imd.ip.setBackground(bgColor);
    	  if (fdatname==null) { // fdatname == null
    		 imd.ip.setToolTipText("no channel, file not found or error");
    		 imd.ip.setBackground(new Color(255,220,220));
    	  }
    	
    }
}
