import javax.sound.sampled.*;

class PlayThread extends Thread{
  byte tempBuffer[] = new byte[10000];
  AudioInputStream audioInputStream;
  SourceDataLine sourceDataLine;
  
  public void run(){
    try{
      int cnt;
      while((cnt = audioInputStream.read(tempBuffer, 0,tempBuffer.length)) != -1) {
        if(cnt > 0) sourceDataLine.write(tempBuffer, 0, cnt);
      }
      sourceDataLine.drain();
      sourceDataLine.close();
    }catch (Exception e) {
      System.out.println("SoundPlayer: "+e);
    }
  }
}