import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.*;

public class saveImageDialog extends JDialog{
	static final long serialVersionUID = 1;
    Checkbox cb_axis,cb_overlay,cb_text;
    JButton b_ok;
	
	saveImageDialog(Frame parent,String title) {
		super(parent,title,true);
        setLayout(new GridBagLayout());
        GridBagConstraints c=new GridBagConstraints();
        
        c.fill=GridBagConstraints.BOTH;
        c.insets=new Insets(5,5,5,5);
        c.weightx=c.weighty=1.0;
        
        cb_axis=new Checkbox(" Axis");
        c.gridx=0;c.gridy=0;c.gridwidth=1;c.gridheight=1;
        add(cb_axis,c);
        cb_overlay=new Checkbox(" Overlays");
        c.gridx=0;c.gridy=1;c.gridwidth=1;c.gridheight=1;
        add(cb_overlay,c);
        cb_text=new Checkbox(" Infotext");
        c.gridx=0;c.gridy=2;c.gridwidth=1;c.gridheight=1;
        add(cb_text,c);
        b_ok=new JButton(" Ok ");
        b_ok.setActionCommand("ok");
        c.gridx=0;c.gridy=3;c.gridwidth=1;c.gridheight=1;
        add(b_ok,c);
        ActionListener bal=new ActionListener() {
	          public void actionPerformed(ActionEvent e) {
	        	String command=e.getActionCommand();
	            if (command.equals("ok")) {
	            	setVisible(false);
	            }
	          }
	        };
	    b_ok.addActionListener(bal);

        
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
              setVisible(false);
            }
          }); // WindowListener

	}

}
