import java.awt.*;
import java.awt.image.*;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

public class GiveColor {

	 int[] colors;
	 GiveColor() {
	   colors=null;
	 }

	 public void grabit(int x,int y,int[] map,Image bild) {
		 PixelGrabber grabber = new PixelGrabber( bild, 0, 0, x, y, map, 0, x );
		 boolean done = false;
		 do {
		   try { 
		     done = grabber.grabPixels( 5000 );  
		   } 
		   catch ( InterruptedException e ) {}
		 } while( !done );
		 if ( (grabber.status() & ImageObserver.ABORT) != 0) System.out.println("Error converting Image to Colormap");
		 }

	 String LoadColors(Frame parent,String fname) {
	        String efile;
	        Image i_cmap;
	        int cmap_size;
	        
	        if (fname==null) {
		    JFileChooser fc = new JFileChooser();
	        FileFilter filter = new FileFilter(){
	        	  public boolean accept(File f) {
	        		  if (f.isDirectory()) return true;
	        		  return (f.getName().endsWith(".png"));
	              }
	        	  public String getDescription() {
	        		  return ("*.png");
	              }
	        	};
	        fc.setFileFilter(filter);
	        fc.setApproveButtonText("Load Image");
	        fc.setApproveButtonToolTipText("Click Me!");
	        int returnVal = fc.showOpenDialog(parent);
	        if(returnVal == JFileChooser.APPROVE_OPTION) {
	           efile=fc.getSelectedFile().getAbsolutePath();
	        } else {
	            if(returnVal == JFileChooser.ERROR_OPTION) {
	              JOptionPane.showMessageDialog(parent,"Error on choosing file !",
	                        "Choose Error",
	                        JOptionPane.ERROR_MESSAGE);
	            } 
	            return null;
	        }
	        } else {
	        	efile=fname;
	        }
	    	MediaTracker tracker=new MediaTracker(parent);
	        Toolkit tk=parent.getToolkit();
	        i_cmap=tk.getImage(efile);

	        tracker.addImage(i_cmap,0);
	        try {tracker.waitForAll();}
	        catch (InterruptedException e) {System.out.println(e.getMessage());return null;}
	        cmap_size=i_cmap.getWidth(null);
	        if (cmap_size>0) {
	        	System.out.println("Colormap has "+cmap_size+" colors");
	        	colors=new int[cmap_size];
	        	grabit(cmap_size,1,colors,i_cmap);
	        } else {
	        	return null;
	        }
            return efile;
	 }
}
