import java.io.File;
import java.io.FilenameFilter;
import java.util.*;

public class parList {

	String[] sortfl(String fl[]) {
		int i;
		boolean exchanged;
		String dummy;

		if (fl != null) {
			// fl sortieren (Bubblesort)
			do {
				exchanged = false;
				for (i = 1; i < fl.length; i++) {
					if (fl[i - 1].compareToIgnoreCase(fl[i]) > 0) {
						exchanged = true;
						dummy = fl[i - 1];
						fl[i - 1] = fl[i];
						fl[i] = dummy;
					}
				}
			} while (exchanged);
		}
		return fl;
	}

	public String[] getList(String dir) {

		int i, i1;
		boolean exchanged;
		String dummy;
		ArrayList filesonly;
		String[] result;

		File f = new File(dir);
		// gives all Files with "mXXX_*.par" where X is a valid Integer Number
		String fl[] = f.list(new FilenameFilter() {
			public boolean accept(File f, String s) {
				boolean b;
				int i;
				String number;
				
                s = s.toLowerCase();
				b = s.endsWith(".par");
				b = b && s.startsWith("m");
				i = s.indexOf("_");
				if (i > 1) {
					b = b && true;
					number = s.substring(1, i);
					try {
						Integer.parseInt(number);
					} catch (Exception e) {
						b = false;
					}
				} else {
					b = false;
				}
				// if (b) System.out.println("with number: "+s);
				return b;
			}
		});
		if (fl != null) {
			int numbers[] = new int[fl.length];
			for (i = 0; i < fl.length; i++) {
				numbers[i] = Integer.parseInt(fl[i].substring(1, fl[i]
						.indexOf("_")));
			}
			// sort it
			do {
				exchanged = false;
				for (i = 1; i < fl.length; i++) {
					if (numbers[i - 1] > numbers[i]) {
						exchanged = true;
						dummy = fl[i - 1];
						fl[i - 1] = fl[i];
						fl[i] = dummy;
						i1 = numbers[i - 1];
						numbers[i - 1] = numbers[i];
						numbers[i] = i1;
					}
				}
			} while (exchanged);
		}

		// and now we get the .par Files with other names and add them to the
		// end
		// f=new File(dir);
		String fil[] = f.list(new FilenameFilter() {
			public boolean accept(File f, String s) {
				boolean b;
				int i;
				String number;

				s = s.toLowerCase();
				b = s.endsWith(".par");
				b = b && s.startsWith("m");
				i = s.indexOf("_");
				if (i > 1) {
					b = b && true;
					number = s.substring(1, i);
					try {
						Integer.parseInt(number);
					} catch (Exception e) {
						b = false;
					}
				} else {
					b = false;
				}
				if (b) {
					b = false;
				} else {
					b = s.endsWith(".par");
				}
				// if (b) System.out.println("no number: "+s);
				return b;
			}
		});
		filesonly = new ArrayList();
		if (fl != null) {
			for (i = 0; i < fl.length; i++) {
				f = new File(dir, fl[i]);
				if (f.isFile())
					filesonly.add(fl[i]);
			}

		}
		if (fil != null) {
			fil = sortfl(fil);
			for (i = 0; i < fil.length; i++) {
				f = new File(dir, fil[i]);
				if (f.isFile())
					filesonly.add(fil[i]);
			}
		}
		result = new String[filesonly.size()];
		for (i = 0; i < filesonly.size(); i++)
			result[i] = (String) filesonly.get(i);
		return result;
	} // getList
}
