import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
//import java.util.*;
import javax.media.j3d.*;
import javax.media.j3d.Locale;
import javax.media.j3d.Raster;
import javax.media.jai.JAI;
//import javax.media.jai.RenderedOp;
import javax.vecmath.*;
//import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.behaviors.mouse.*;
//import com.sun.j3d.utils.geometry.Box;
import com.sun.media.jai.codec.PNGEncodeParam;
import javax.swing.*;

//import java.awt.color.ColorSpace;

public class stml3dview extends Frame implements MouseBehaviorCallback {

	static final long serialVersionUID=1;
	
float viewheight=1;
float scR=1,scG=0.5f,scB=0;
float lcR=1,lcG=1,lcB=0;
String cm_file="";
float xyzoom=3f;
float shiny=64f;
float zzoom=0.2f;

float cm_r[]=null,cm_g[]=null,cm_b[]=null;
int cmap_size=0;
boolean colmap;

int xsize,ysize;
float[] hdata;
float max_height;

boolean metal=true;
TextArea ta_info;
SimpleUniverse u;
boolean abortdd3d=false;
Transform3D trans;
TransformGroup group;
PointLight plight=null;
AmbientLight alight;
TriangleArray tri;
Canvas3D canvas;
Canvas canvas1;
BranchGroup root;

Matrix3d mat_trans;
Vector3d vec_trans;
double scale;
// Achsenwinkel
double angx=0,angy=0,angz=0;
JLabel jla;



class d3ddialog extends Dialog {
	  static final long serialVersionUID=1;
      TextField tf_scR,tf_scG,tf_scB;
      TextField tf_lcR,tf_lcG,tf_lcB;
      TextField tf_cmfile,tf_zoom,tf_shiny,tf_zzoom;
      Button b_browse,b_ok;
      Checkbox cb_metal;
      Font fo;
      int fontsize=12;
      
      d3ddialog(Frame parent,String title) {
        
        super(parent,title,true);

        setLayout(new GridBagLayout());
        GridBagConstraints c=new GridBagConstraints();
        fo=new Font("SansSerif",Font.PLAIN,fontsize);
        setFont(fo);
        c.fill=GridBagConstraints.BOTH;
        c.insets=new Insets(5,5,5,5);
        c.weightx=c.weighty=0.0;
        c.gridx=0;c.gridy=0;c.gridwidth=1;c.gridheight=1;
        add(new Label("Surface Color RGB (0 to 1.0): "),c);
        tf_scR=new TextField(""+scR);
        tf_scG=new TextField(""+scG);
        tf_scB=new TextField(""+scB);
        c.gridx=1;c.gridy=0;c.gridwidth=1;c.gridheight=1;
        add(tf_scR,c);
        c.gridx=2;c.gridy=0;c.gridwidth=1;c.gridheight=1;
        add(tf_scG,c);
        c.gridx=3;c.gridy=0;c.gridwidth=1;c.gridheight=1;
        add(tf_scB,c);
        c.gridx=0;c.gridy=1;c.gridwidth=1;c.gridheight=1;
        add(new Label("Use ColorMap from File: "),c);
        tf_cmfile=new TextField(cm_file);
        c.gridx=1;c.gridy=1;c.gridwidth=2;c.gridheight=1;
        add(tf_cmfile,c);
        b_browse=new Button(" Browse ");
        b_browse.setActionCommand("browse");
        c.gridx=3;c.gridy=1;c.gridwidth=1;c.gridheight=1;
        add(b_browse,c);
        cb_metal=new Checkbox("Metallic Look",metal);
        c.gridx=0;c.gridy=2;c.gridwidth=1;c.gridheight=1;
        add(cb_metal,c);
        c.gridx=0;c.gridy=3;c.gridwidth=1;c.gridheight=1;
        add(new Label("Shinyness (1.0 to 128.0): "),c);
        tf_shiny=new TextField(""+shiny);
        c.gridx=1;c.gridy=3;c.gridwidth=1;c.gridheight=1;
        add(tf_shiny,c);
        c.gridx=0;c.gridy=4;c.gridwidth=1;c.gridheight=1;
        add(new Label("Specular light color RGB (0 to 1.0): "),c);
        tf_lcR=new TextField(""+lcR);
        tf_lcG=new TextField(""+lcG);
        tf_lcB=new TextField(""+lcB);
        c.gridx=1;c.gridy=4;c.gridwidth=1;c.gridheight=1;
        add(tf_lcR,c);
        c.gridx=2;c.gridy=4;c.gridwidth=1;c.gridheight=1;
        add(tf_lcG,c);
        c.gridx=3;c.gridy=4;c.gridwidth=1;c.gridheight=1;
        add(tf_lcB,c);
        c.gridx=0;c.gridy=5;c.gridwidth=1;c.gridheight=1;
        add(new Label("XY Zoom: "),c);
        tf_zoom=new TextField(""+xyzoom);
        c.gridx=1;c.gridy=5;c.gridwidth=1;c.gridheight=1;
        add(tf_zoom,c);
        c.gridx=0;c.gridy=6;c.gridwidth=1;c.gridheight=1;
        add(new Label("Z Zoom: "),c);
        tf_zzoom=new TextField(""+zzoom);
        c.gridx=1;c.gridy=6;c.gridwidth=1;c.gridheight=1;
        add(tf_zzoom,c);
        b_ok=new Button("Show");
        b_ok.setActionCommand("ok");
        c.gridx=0;c.gridy=7;c.gridwidth=4;c.gridheight=1;
        add(b_ok,c);
        tf_shiny.setEnabled(cb_metal.getState());
        tf_lcR.setEnabled(cb_metal.getState());
        tf_lcG.setEnabled(cb_metal.getState());
        tf_lcB.setEnabled(cb_metal.getState());
        
        cb_metal.addItemListener(new ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            tf_shiny.setEnabled(cb_metal.getState());
            tf_lcR.setEnabled(cb_metal.getState());
            tf_lcG.setEnabled(cb_metal.getState());
            tf_lcB.setEnabled(cb_metal.getState());
          }
        });


        ActionListener b_al=new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            String command=e.getActionCommand();
            if (command.equals("ok")) {
              try {
                scR=Float.parseFloat(tf_scR.getText());
                scG=Float.parseFloat(tf_scG.getText());
                scB=Float.parseFloat(tf_scB.getText());
                lcR=Float.parseFloat(tf_lcR.getText());
                lcG=Float.parseFloat(tf_lcG.getText());
                lcB=Float.parseFloat(tf_lcB.getText());
                shiny=Float.parseFloat(tf_shiny.getText());
                xyzoom=Float.parseFloat(tf_zoom.getText());
                zzoom=Float.parseFloat(tf_zzoom.getText());
                cm_file=tf_cmfile.getText();
                metal=cb_metal.getState();
              } catch (Exception ex) {
                System.out.println(ex.getMessage());
              }
              dispose();
            }
            if (command.equals("browse")) {
              FileDialog d = new FileDialog(stml3dview.this,"Load Colormap Image",FileDialog.LOAD);
              d.setFile("*.*");
              d.setDirectory(".");
              d.setVisible(true);
              String efile=d.getFile();
              String edir=d.getDirectory();
              d.dispose();
              if (!(efile==null) && !(edir==null)) {
                tf_cmfile.setText(edir+efile);
              };
            }
          }
        };
        b_ok.addActionListener(b_al);
        b_browse.addActionListener(b_al);
        addWindowListener(new WindowAdapter() {
          public void windowClosing(WindowEvent e) {
            abortdd3d=true;
            dispose();
          }
        }); // WindowListener
      }
}

public void grabit(int x,int y,int[] map,Image bild) {
PixelGrabber grabber = new PixelGrabber( bild, 0, 0, x, y, map, 0, x );
boolean done = false;
do {
  try { 
    done = grabber.grabPixels( 5000 );  
  } 
  catch ( InterruptedException e ) {}
} while( !done );
if ( (grabber.status() & ImageObserver.ABORT) != 0) System.out.println("Error converting Image to Colormap");
}

public void transformChanged(int type,Transform3D t3d){
  switch (type) {
    case MouseBehaviorCallback.ROTATE : {}
    case MouseBehaviorCallback.TRANSLATE : {}
    case MouseBehaviorCallback.ZOOM : {}
  }
}

void getcolmap() {
    int pixmap[];
    Image i_cmap;
    int i,j;
    
	MediaTracker tracker=new MediaTracker(this);
    Toolkit tk=getToolkit();
    i_cmap=tk.getImage(cm_file);

    tracker.addImage(i_cmap,0);
    try {tracker.waitForAll();}
    catch (InterruptedException e) {System.out.println(e.getMessage());}
    cmap_size=i_cmap.getWidth(null);
    System.out.println("Colormap has "+cmap_size+" colors");
    pixmap=new int[cmap_size];
    grabit(cmap_size,1,pixmap,i_cmap);
    cm_r=new float[cmap_size];
    cm_g=new float[cmap_size];
    cm_b=new float[cmap_size];
    for(i=0;i<cmap_size;i++) {
      j=(pixmap[i] >> 16) & 0x000000ff;
      cm_r[i]=j/(float) (255);
      j=(pixmap[i] >> 8) & 0x000000ff;
      cm_g[i]=j/(float) (255);
      j=pixmap[i] & 0x000000ff;
      cm_b[i]=j/(float) (255);
    }
}

void calcheightmap(int data[][], int xsi,int ysi,int minc,int maxc) {
    float delta,val;
    int i,j;
    hdata = new float[xsi*ysi];
	delta=maxc-minc;
	  if (delta<1) delta=1;
	  max_height=Float.MIN_VALUE;
	  for(i=0;i<ysi;i++) {
	    for(j=0;j<xsi;j++) {
	      if (data[j][i]<minc) {
	        val=0;
	      } else {
	        if (data[j][i]>maxc) {
	          val=1f;
	        } else {
	          val=(data[j][i]-minc)/delta;
	        }
	      }
	      hdata[j+i*xsi]=val;
	      if (val>max_height) max_height=val;
	    }
	  }
}

void setupgeometry(TriangleArray tri,int xsize,int ysize,boolean colmap) {
    Vector3f v01,v02,v03,v04,v05,v06,vno1,vno2;
    Point3f p1,p2,p3,p4;
    Color3f c1,c2,c3,c4;
    int ysiz1=ysize-1;
    int xsiz1=xsize-1;
    int midx=xsize/2;
    int midy=ysize/2;
    int i,j,k,l,m;
    float dscaler;
    
    dscaler=midx/xyzoom;
      c1 = new Color3f();
	  c2 = new Color3f();
	  c3 = new Color3f();
	  c4 = new Color3f();
	  p1 = new Point3f();
	  p2 = new Point3f();
	  p3 = new Point3f();
	  p4 = new Point3f();
	  v01 = new Vector3f();
	  v02 = new Vector3f();
	  v03 = new Vector3f();
	  v04 = new Vector3f();
	  v05 = new Vector3f();
	  v06 = new Vector3f();
	  vno1 = new Vector3f();
	  vno2 = new Vector3f();
	  k=0;
	  for(i=0;i<ysiz1;i++) {
	    for(j=0;j<xsiz1;j++) {
	      l=6*(i*xsiz1+j);
	      // block
	      // 1 2
	      // 3 4
	          
	      p1=new Point3f((i-midx)  /dscaler,(j-midy)  /dscaler,zzoom*hdata[k    ]-viewheight);
	      p2=new Point3f((i-midx)  /dscaler,(j+1-midy)/dscaler,zzoom*hdata[k+1  ]-viewheight);
	      p3=new Point3f((i+1-midx)/dscaler,(j-midy)  /dscaler,zzoom*hdata[k+xsize]-viewheight);
	      p4=new Point3f((i+1-midx)/dscaler,(j+1-midy)/dscaler,zzoom*hdata[k+xsize+1]-viewheight);

	      v01.sub(p2,p3);
	      v02.sub(p1,p3);
	      vno1.cross(v01, v02);
	      vno1.normalize();
	      v01.sub(p4,p3);
	      v02.sub(p2,p3);
	      vno2.cross(v01, v02);
	      vno2.normalize();

	      tri.setCoordinate(l+2,p1);
	      tri.setCoordinate(l+1,p2);
	      tri.setCoordinate(l  ,p3);
	      tri.setCoordinate(l+5,p2);
	      tri.setCoordinate(l+4,p4);
	      tri.setCoordinate(l+3,p3);
	      tri.setNormal(l  ,vno1);
	      tri.setNormal(l+1,vno1);
	      tri.setNormal(l+2,vno1);
	      tri.setNormal(l+5,vno2);
	      tri.setNormal(l+3,vno2);
	      tri.setNormal(l+4,vno2);
	      if (colmap) {
	        m=(int) ((cmap_size-1)*hdata[k]/max_height);
	        c1=new Color3f(cm_r[m],cm_g[m],cm_b[m]);
	        m=(int) ((cmap_size-1)*hdata[k+1]/max_height);
	        c2=new Color3f(cm_r[m],cm_g[m],cm_b[m]);
	        m=(int) ((cmap_size-1)*hdata[k+xsize]/max_height);
	        c3=new Color3f(cm_r[m],cm_g[m],cm_b[m]);
	        m=(int) ((cmap_size-1)*hdata[k+1+xsize]/max_height);
	        c4=new Color3f(cm_r[m],cm_g[m],cm_b[m]);
	      } else {
	        c1=new Color3f(scR*hdata[k],scG*hdata[k],scB*hdata[k]);
	        c2=new Color3f(scR*hdata[k+1],scG*hdata[k+1],scB*hdata[k+1]);
	        c3=new Color3f(scR*hdata[k+xsize],scG*hdata[k+xsize],scB*hdata[k+xsize]);
	        c4=new Color3f(scR*hdata[k+1+xsize],scG*hdata[k+1+xsize],scB*hdata[k+1+xsize]);
	      }
	      tri.setColor(l+2,c1);
	      tri.setColor(l+1,c2);
	      tri.setColor(l  ,c3);
	      tri.setColor(l+5,c2);
	      tri.setColor(l+4,c4);
	      tri.setColor(l+3,c3);
	      k++;
	    }
	    k++;
	  }
	  // Normalenvektoren mitteln f?r weiche Kanten
	  for(i=1;i<ysiz1;i++) {
	    for(j=1;j<xsiz1;j++) {
	  // 4 Hoehenpixel bilden zwei Dreiecke mit den Punkten
	  //  1   2
	  //  3   4
	  // 6er block hat zwei Dreiecke mit 1,2,3  2,4,3  Clockwise
	  // so im Dreiecksarray             2 1 0  5 4 3
	  // also  2   1|5
	  //       0|3   4

	      l=6*(i*xsiz1+j);
	      tri.getNormal(l-6*xsiz1-6+4,v01); // punkt 2, dreieck 2 im block links oben
	      tri.getNormal(l-6*xsiz1  +0,v02); // punkt 3, dreieck 1 im block oben
	      tri.getNormal(l-6*xsiz1  +3,v03); // punkt 3, dreieck 2 im block oben
	      tri.getNormal(l          +2,v04); // punkt 1, dreieck 1 im aktuellen block
	      tri.getNormal(l        -6+5,v05); // punkt 2, dreieck 2 im linken block
	      tri.getNormal(l        -6+1,v06); // punkt 2, dreieck 1 im linken block
	      v01.add(v02);
	      v01.add(v03);
	      v01.add(v04);
	      v01.add(v05);
	      v01.add(v06);
	      v01.normalize();
	      tri.setNormal(l-6*xsiz1-6 +4,v01);
	      tri.setNormal(l-6*xsiz1   +0,v01);
	      tri.setNormal(l-6*xsiz1   +3,v01);
	      tri.setNormal(l           +2,v01);
	      tri.setNormal(l         -6+5,v01);
	      tri.setNormal(l         -6+1,v01);
	    }
	  }
	  for(i=1;i<ysiz1;i++) {
	    l=6*(i*xsiz1);
	    tri.getNormal(l-6*xsiz1+0,v01);
	    tri.getNormal(l-6*xsiz1+3,v02);
	    tri.getNormal(l        +2,v03);
	    v01.add(v02);
	    v01.add(v03);
	    v01.normalize();
	    tri.setNormal(l-6*xsiz1+0,v01);
	    tri.setNormal(l-6*xsiz1+3,v01);
	    tri.setNormal(l        +2,v01);

	    l=6*(i*xsiz1+xsiz1-1);
	    tri.getNormal(l-6*xsiz1+4,v01);
	    tri.getNormal(l        +1,v02);
	    tri.getNormal(l        +5,v03);
	    v01.add(v02);
	    v01.add(v03);
	    v01.normalize();
	    tri.setNormal(l-6*xsiz1+4,v01);
	    tri.setNormal(l        +1,v01);
	    tri.setNormal(l        +5,v01);
	  }
	  for(j=1;j<xsiz1;j++) {
	    l=6*(j);
	    tri.getNormal(l-6+1,v01);
	    tri.getNormal(l-6+5,v02);
	    tri.getNormal(l  +2,v03);
	    v01.add(v02);
	    v01.add(v03);
	    v01.normalize();
	    tri.setNormal(l-6+1,v01);
	    tri.setNormal(l-6+5,v01);
	    tri.setNormal(l  +2,v01);
	    l=6*(xsiz1*(ysiz1-1)+j);
	    tri.getNormal(l-6+4,v01);
	    tri.getNormal(l  +0,v02);
	    tri.getNormal(l  +3,v03);
	    v01.add(v02);
	    v01.add(v03);
	    v01.normalize();
	    tri.setNormal(l-6+4,v01);
	    tri.setNormal(l  +0,v01);
	    tri.setNormal(l  +3,v01);
	  }
}

public stml3dview(int data[][],int xs,int ys,int min_ch,int max_ch) {

    int i,j,k,l,m;
    Appearance app;
    ColoringAttributes colatt;
    int allpoints;
    Material app_mate;
    Color3f c_ambient,c_diffuse,c_specular,c_emissive,c_alight,c_plight=null;
    
Dialog d3dd=new d3ddialog(this,"Set 3D Scene Parameters");
d3dd.pack();
d3dd.setVisible(true);
if (!abortdd3d) {
  xsize=xs;
  ysize=ys;
  c_alight=new Color3f(Color.WHITE);
  if (metal) {
    c_plight=new Color3f(lcR,lcG,lcB);
  }

  if ((cm_file!=null) && (!cm_file.equals(""))) {colmap=true;}else{colmap=false;}
  if (colmap) getcolmap();

  System.out.println("Generating 3D Scene");
  System.out.println("--> Calculating Height Map");
  calcheightmap(data,xsize,ysize,min_ch,max_ch);

  mat_trans=new Matrix3d();
  vec_trans=new Vector3d();
  trans=new Transform3D();
  trans.rotX(-Math.PI/2);
  group=new TransformGroup(trans);
  group.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
  group.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);

  allpoints=3*2*(xsize-1)*(ysize-1);
  System.out.println("--> Setting up 3D Mesh of "+allpoints+" Triangles");
  tri =  new TriangleArray(allpoints,TriangleArray.COORDINATES | 
                                                   TriangleArray.NORMALS     |
                                                   TriangleArray.COLOR_3);
  tri.setCapability(TriangleArray.ALLOW_COLOR_READ);
  tri.setCapability(TriangleArray.ALLOW_COLOR_WRITE);
  tri.setCapability(TriangleArray.ALLOW_COORDINATE_READ);
  tri.setCapability(TriangleArray.ALLOW_COORDINATE_WRITE);
  tri.setCapability(TriangleArray.ALLOW_COUNT_READ);
  tri.setCapability(TriangleArray.ALLOW_NORMAL_READ);
  tri.setCapability(TriangleArray.ALLOW_NORMAL_WRITE);

  setupgeometry(tri,xsize,ysize,colmap);
  System.out.println("--> Setting up 3D Scene");
  app=new Appearance();
//app.setColoringAttributes(new ColoringAttributes(new Color3f(Color.WHITE),ColoringAttributes.NICEST));

  if (metal) {
    app_mate=new Material();
    app_mate.setLightingEnable(true);
    app_mate.setColorTarget(Material.AMBIENT);
    app_mate.setShininess(shiny);
    app.setMaterial(app_mate);
  }

  Shape3D s3d=new Shape3D(tri,app);

  group.addChild(s3d);

  BoundingSphere bounds = new BoundingSphere(new Point3d(0,0,0), Double.MAX_VALUE);

  MouseRotate behav1=new MouseRotate(group);
  behav1.setSchedulingBounds(bounds);
  behav1.setupCallback(this);
  group.addChild(behav1);
  MouseTranslate behav2=new MouseTranslate(group);
  behav2.setSchedulingBounds(bounds);
  behav2.setupCallback(this);
  group.addChild(behav2);
  MouseZoom behav3=new MouseZoom(group);
  behav3.setSchedulingBounds(bounds);
  behav3.setupCallback(this);
  group.addChild(behav3);

  alight=new AmbientLight(c_alight);
  alight.setInfluencingBounds(bounds);
  alight.setCapability(AmbientLight.ALLOW_COLOR_WRITE);
  if (metal) {
    plight=new PointLight(true,c_plight,new Point3f(.2f,.2f,max_height+viewheight),new Point3f(2f,0,0));
    plight.setInfluencingBounds(bounds);
    plight.setCapability(PointLight.ALLOW_COLOR_WRITE);
    plight.setCapability(PointLight.ALLOW_POSITION_WRITE);
  }

  root=new BranchGroup();
  root.setCapability(BranchGroup.ALLOW_DETACH);
  root.addChild(alight);
  if (metal) root.addChild(plight);
  root.addChild(group);
  root.compile();


  GraphicsConfiguration c = SimpleUniverse.getPreferredConfiguration();
  canvas= new Canvas3D(c);
/*
  canvas.getScreen3D().setSize(400,300);
  canvas.getScreen3D().setPhysicalScreenHeight(3d);
  canvas.getScreen3D().setPhysicalScreenWidth(4d);
  bufimg=new BufferedImage(400,300,BufferedImage.TYPE_INT_ARGB);
  ImageComponent2D ic=new ImageComponent2D(ImageComponent2D.FORMAT_RGBA8,bufimg);
//  ic.set(bi);
  canvas.setOffScreenBuffer(ic);
*/
  u = new SimpleUniverse(canvas);
  u.getViewingPlatform().setNominalViewingTransform();
  u.addBranchGraph(root);
//  canvas.startRenderer();

  System.out.println("--> Putting 3D Scene into window");
  setLayout(new BorderLayout());
//  jla=new JLabel(new ImageIcon(canvas.getOffScreenBuffer().getImage()));
  setTitle("3D Viewer");
/*
  ta_info=new TextArea(4,80);
  add(ta_info,BorderLayout.SOUTH);
  ta_info.setEditable(false);
  
  */
canvas.addKeyListener(new KeyAdapter(){
    public void keyPressed(KeyEvent ke) {
//        Locale loc;
        boolean rg=false;
        Matrix3d mat_rota=new Matrix3d(0,0,0,0,0,0,0,0,0);
    	group.getTransform(trans);
        scale=trans.get(mat_trans,vec_trans);
    	int k=ke.getKeyCode();
        switch (k) {
          case KeyEvent.VK_P : {scale*=1.1;break;}
          case KeyEvent.VK_O : {scale*=0.9;break;}

          case KeyEvent.VK_Q : {vec_trans.x-=.03;break;}
          case KeyEvent.VK_A : {vec_trans.y-=.03;break;}
          case KeyEvent.VK_Z : {vec_trans.z-=.03;break;}
          case KeyEvent.VK_W : {vec_trans.x+=.03;break;}
          case KeyEvent.VK_S : {vec_trans.y+=.03;break;}
          case KeyEvent.VK_X : {vec_trans.z+=.03;break;}

          case KeyEvent.VK_E : {angx=-0.1;break;}
          case KeyEvent.VK_R : {angx=0.1;break;}

          case KeyEvent.VK_D : {angy=-0.1;break;}
          case KeyEvent.VK_F : {angy=0.1;break;}

          case KeyEvent.VK_C : {angz=-0.1;break;}
          case KeyEvent.VK_V : {angz=0.1;break;}

          case KeyEvent.VK_N : {alight.setColor(new Color3f(0f,0f,0f));break;}
          case KeyEvent.VK_M : {alight.setColor(new Color3f(1f,1f,1f));break;}

          case KeyEvent.VK_J : {zzoom*=0.7;rg=true;break;}
          case KeyEvent.VK_K : {zzoom*=1.5;rg=true;break;}
          case KeyEvent.VK_1 : {scR=0;rg=true;break;}
          case KeyEvent.VK_2 : {scR=1;rg=true;break;}
          case KeyEvent.VK_3 : {scG=0;rg=true;break;}
          case KeyEvent.VK_4 : {scG=1;rg=true;break;}
          case KeyEvent.VK_5 : {scB=0;rg=true;break;}
          case KeyEvent.VK_6 : {scB=1;rg=true;break;}
          case KeyEvent.VK_F12 : {
              RenderedImage ri;
//              RenderedOp op;
              PNGEncodeParam png_ep;
              png_ep=new PNGEncodeParam.RGB();

              /*
              canvas.waitForOffScreenRendering();
              ri=canvas.getOffScreenBuffer().getRenderedImage();
*/
              GraphicsContext3D  ctx = canvas.getGraphicsContext3D();
      	    // The raster components need all be set!
      	    Raster ras = new Raster(
                         new Point3f(-1.0f,-1.0f,-1.0f),
      		                         Raster.RASTER_COLOR,
      		                         0,0,
      		                         getWidth(),getHeight(),
                                    new ImageComponent2D(ImageComponent.FORMAT_RGB,
      			                    new BufferedImage(getWidth(),getHeight(),
      					            BufferedImage.TYPE_INT_RGB)),
      		                        null);

      	    ctx.readRaster(ras);
      	    // Now strip out the image info
      	    ri = ras.getImage().getRenderedImage();
            
            String fname=getfname();
      	    if (fname!=null) {
        	  JAI.create("filestore",ri,fname,"png",png_ep);
            }
          }
        };
        if (rg) {
            root.detach();
          	setupgeometry(tri,xsize,ysize,colmap);
          	u.addBranchGraph(root);
        }
        if ((k==KeyEvent.VK_E) || (k==KeyEvent.VK_R)) {
          mat_rota.rotX(angx);
          mat_trans.mulNormalize(mat_rota);
        }
        if ((k==KeyEvent.VK_D) || (k==KeyEvent.VK_F)) {
            mat_rota.rotY(angy);
            mat_trans.mulNormalize(mat_rota);
          }
        if ((k==KeyEvent.VK_C) || (k==KeyEvent.VK_V)) {
            mat_rota.rotZ(angz);
            mat_trans.mulNormalize(mat_rota);
          }
//      Rotation um X-Achse
        trans.set(mat_trans,vec_trans,scale);
        group.setTransform(trans);
    }

  });

//add(jla);
add(canvas);

} // ende stml3dview constructor

addWindowListener(new WindowAdapter() {
  public void windowClosing(WindowEvent e) {
    u.removeAllLocales();
  	u.cleanup();
    dispose();
  }
}); // WindowListener
}

String getfname() {
    FileDialog d = new FileDialog(this,"Save PNG-Image",FileDialog.SAVE);
    d.setDirectory(".");
    d.setVisible(true);
    String efile=d.getFile();
    String edir=d.getDirectory();
    d.dispose();
    if ((edir==null) || (efile==null)) {
      return null;
    } else {
      return (edir+efile);
    }
}

}
